<template>
  <v-row>
    <v-col> Cert verifier test </v-col>
  </v-row>
</template>

<script>
import { Certificate } from 'oscity-cert-verifier-js'

export default {
  data() {
    return {
      data: null,
    }
  },
  mounted() {
    const self = this
    this.$fire.storage
      .ref()
      .child(`signed_mar_de_plata/${this.$route.params.id}.json`)
      .getDownloadURL()
      .then((url) => {
        const xhr = new XMLHttpRequest()
        xhr.responseType = 'json'
        xhr.open('GET', url, true)
        xhr.onload = () => {
          self.data = xhr.response
          console.log(self.data)
          self.verify()
        }
        xhr.send()
      })
      .catch((error) => {
        console.error(error)
      })
  },
  methods: {
    async verify() {
      const self = this
      let url = ''
      if (process.env.NODE_ENV !== 'development') {
        url = `${process.env.OSCITY_ENDPOINTS_URL}/parsing-ethereum-rpcparsingfunction`
      } else {
        url =
          'http://localhost:5001/mar-de-plata/us-central1/parsing-ethereum-rpcparsingfunction'
      }
      const certificate = new Certificate(this.data, {
        explorerAPIs: [
          {
            priority: 1,
            apiType: 'rpc',
            async parsingFunction(conf) {
              return await self.$axios.$post(url, conf)
            },
            serviceURL: 'http://35.239.55.127/nodo/',
          },
        ],
        locale: 'es-MX',
      })
      await certificate.init()
      const verificationResult = await certificate.verify(
        ({ code, label, status, errorMessage }) => {
          console.log('Code:', code, label, ' - Status:', status)
          if (errorMessage) {
            console.error(
              `The step ${code} fails with the error: ${errorMessage}`
            )
          }
        }
      )
      if (verificationResult.status === 'failure') {
        console.error(
          `The certificate is not valid. Error: ${verificationResult.message}`
        )
      }
    },
  },
}
</script>
